## spring 98.0+dfsg

=== AI/CMakeLists.txt ===
### AI
#
# Global variables set in this file:
# * AI_EXCLUDE_REGEX
# * AI_FIND_QUIETLY
# * DEPS_AI_ALL
#
# Functions and macros defined in this file:
# * AIMessage
#

add_definitions(-DBUILDING_AI)


### User-definable build options
set (AI_EXCLUDE_REGEX "XXXXXXXX" CACHE STRING "Which Skirmish AIs not to build (none by default, example: \"NTai|Null.*AI\", see also: AI_TYPES")
option(AI_FIND_QUIETLY  "Whether to find AI Interfaces and Skirmish AIs quietly" FALSE)

set(rts             "${CMAKE_SOURCE_DIR}/rts")

include_directories(
	${rts}
	${CMAKE_BINARY_DIR}/src-generated/engine
	${rts}/ExternalAI/Interface
	Wrappers
	)

# Set these for Interfaces and AIs with C sources
set(CMAKE_C_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG}")
set(CMAKE_C_FLAGS_DEBUG2         "${CMAKE_CXX_FLAGS_DEBUG2}")
set(CMAKE_C_FLAGS_DEBUG3         "${CMAKE_CXX_FLAGS_DEBUG3}")
set(CMAKE_C_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE}")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
set(CMAKE_C_FLAGS_PROFILE        "${CMAKE_CXX_FLAGS_PROFILE}")

remove_definitions(-DSTREFLOP_SSE)
add_definitions(${PIC_FLAG} -D_REENTRANT -D_GNU_SOURCE=1)

if    (MINGW)
	set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--kill-at -Wl,--add-stdcall-alias")
endif (MINGW)


# Assemble common additional native AI sources
list(APPEND ai_common_SRC "${rts}/Game/GameVersion.cpp")
list(APPEND ai_common_SRC "${rts}/System/SafeCStrings.c")


# Set some Skirmish AI stuff here already,
# cause it is used by NullPythonAI in Interfaces/Python

# Export Paths needed for the AIs
set(SKIRMISH_AI_LIBS        "${AI_LIBS_DIR}/AI/Skirmish")
set(SKIRMISH_AI_DATA        "${AI_DATA_DIR}/AI/Skirmish")

# Display messages on configure, which AIs are found
set(SKIRMISHAI_FIND_QUIETLY ${AI_FIND_QUIETLY})

MakeGlobal(SKIRMISH_AI_LIBS SKIRMISH_AI_DATA SKIRMISHAI_FIND_QUIETLY)


# Print a message, but only if we are allowed to speak.
macro    (AIMessage type msg)
	if    (NOT AI_FIND_QUIETLY)
		message(${type} "${msg}")
	endif (NOT AI_FIND_QUIETLY)
endmacro (AIMessage type msg)


find_package(AWK)

# CUtils has to come first, because the Interfaces use it too
Add_Subdirectory(Wrappers/CUtils)
Add_Subdirectory(Interfaces)
Add_Subdirectory(Wrappers)
Add_Subdirectory(Skirmish)

set(DEPS_AI_ALL
		${DEPS_AI_INTERFACES}
		${DEPS_AI_WRAPPERS}
		${DEPS_AI_SKIRMISH}
	)
MakeGlobal(DEPS_AI_ALL)

=== test/CMakeLists.txt ===
# See README.md for usage instructions

FIND_PACKAGE(Boost 1.35.0 COMPONENTS unit_test_framework)

If    (NOT Boost_FOUND)
	Message(STATUS "Note: Unit tests will not be built: Boost::test library was not found")
Else  (NOT Boost_FOUND)
	# defines spring_test_compile_fail macro
	INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/tools/CompileFailTest/CompileFailTest.cmake)


	INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
	INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/src-generated/engine)

	SET(ENGINE_SOURCE_DIR "${CMAKE_SOURCE_DIR}/rts")
	INCLUDE_DIRECTORIES(${ENGINE_SOURCE_DIR})

	If	(NOT (WIN32 OR Boost_USE_STATIC_LIBS))
		#Win32 tests links static
		add_definitions(-DBOOST_TEST_DYN_LINK)
	EndIf	(NOT (WIN32 OR Boost_USE_STATIC_LIBS))
	add_definitions(-DSYNCCHECK -DUNIT_TEST)
	REMOVE_DEFINITIONS(-DTHREADPOOL)

	Set(test_Log_sources
			"${ENGINE_SOURCE_DIR}/System/SafeCStrings.c"
			"${ENGINE_SOURCE_DIR}/System/Log/Backend.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/LogUtil.c"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFilter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/DefaultFormatter.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FramePrefixer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/ConsoleSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/StreamSink.cpp"
		)

	Add_Custom_Target(tests)
	add_custom_target(check ${CMAKE_CTEST_COMMAND} --output-on-failure -V
		DEPENDS engine-headless)
	add_custom_target(install-tests)

	macro (add_spring_test target sources libraries flags)
		ADD_TEST(NAME test${target} COMMAND test_${target})
		add_dependencies(tests test_${target})
		add_dependencies(check test_${target})
		add_dependencies(install-tests test_${target})
		add_executable(test_${target} EXCLUDE_FROM_ALL ${sources})
		target_link_libraries(test_${target} ${libraries})
		set_target_properties(test_${target} PROPERTIES COMPILE_FLAGS "${flags}")
		#install(TARGETS test_${target} DESTINATION ${BINDIR})
	endmacro()

################################################################################
### UDPListener
	set(test_name UDPListener)
	Set(test_src
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Net/TestUDPListener.cpp"
		"${ENGINE_SOURCE_DIR}/Game/GameVersion.cpp"
		"${ENGINE_SOURCE_DIR}/Net/Protocol/BaseNetProtocol.cpp"
		"${ENGINE_SOURCE_DIR}/System/CRC.cpp"
		"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
		## HACK:
		##   the engineSystemNet lib is compiled *without* -DUNIT_TEST
		##   it includes UDPConnection which depends on ConfigHandler
		##   in normal builds, but fails to link when used as part of
		##   UT so we compile it again
		"${ENGINE_SOURCE_DIR}/System/Net/UDPConnection.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/NullGlobalConfig.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Nullerrorhandler.cpp"
		${test_Log_sources}
	)

	set(test_libs
		engineSystemNet
		${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		${Boost_SYSTEM_LIBRARY}
		${Boost_THREAD_LIBRARY}
		${Boost_CHRONO_LIBRARY_WITH_RT}
		${WINMM_LIBRARY}
		${WS2_32_LIBRARY}
		7zip
	)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	Add_Dependencies(test_UDPListener generateVersionFiles)

################################################################################
### ILog
	set(test_name ILog)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Log/TestILog.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/FileSink.cpp"
			"${ENGINE_SOURCE_DIR}/System/Log/OutputDebugStringSink.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
### SyncedPrimitive
	set(test_name SyncedPrimitive)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Sync/TestSyncedPrimitive.cpp"
			"${ENGINE_SOURCE_DIR}/System/Sync/SyncChecker.cpp"
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
### RectangleOptimizer
	set(test_name RectangleOptimizer)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/RectangleOptimizer.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/RectangleOptimizer.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG")

################################################################################
### Float3
	set(test_name Float3)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testFloat3.cpp"
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
### Matrix44f
	set(test_name Matrix44f)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testMatrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/Matrix44f.cpp"
			"${ENGINE_SOURCE_DIR}/System/float3.cpp"
			"${ENGINE_SOURCE_DIR}/System/float4.cpp"
			"${ENGINE_SOURCE_DIR}/System/TimeProfiler.cpp"
			"${ENGINE_SOURCE_DIR}/System/UnsyncedRNG.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${WINMM_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")

################################################################################
### SpringTime
	set(test_name SpringTime)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/testSpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/TimeProfiler.cpp"
			"${ENGINE_SOURCE_DIR}/System/UnsyncedRNG.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${Boost_THREAD_LIBRARY}
		)

	IF (WIN32)
		LIST(APPEND test_libs ${WINMM_LIBRARY})
	ENDIF (WIN32)

	set(test_flags "-DNOT_USING_CREG -DNOT_USING_STREFLOP -DBUILDING_AI")
	if (Boost_TIMER_FOUND)
		LIST(APPEND test_libs ${Boost_TIMER_LIBRARY})
		set(test_flags "${test_flags} -DBoost_TIMER_FOUND")
	endif (Boost_TIMER_FOUND)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "${test_flags}")


################################################################################
### BitwiseEnum
	set(test_name BitwiseEnum)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/Misc/TestBitwiseEnum.cpp"
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)

	# positive tests (should compile fine)
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	Add_Dependencies(tests test_BitwiseEnum)

	# negative tests (must not compile)
	spring_test_compile_fail(testBitwiseEnum_fail1 ${test_src} "-DTEST1")
	spring_test_compile_fail(testBitwiseEnum_fail2 ${test_src} "-DTEST2")
	spring_test_compile_fail(testBitwiseEnum_fail3 ${test_src} "-DTEST3")


################################################################################
### FileSystem
	set(test_name FileSystem)
	Set(test_src
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystem.cpp"
			"${ENGINE_SOURCE_DIR}/System/FileSystem/FileSystemAbstraction.cpp"
			"${ENGINE_SOURCE_DIR}/System/Util.cpp"
			"${ENGINE_SOURCE_DIR}/Game/GameVersion.cpp"
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/FileSystem/TestFileSystem.cpp"
			${test_Log_sources}
		)
	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_FILESYSTEM_LIBRARY}
			${Boost_SYSTEM_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	add_dependencies(test_${test_name} generateVersionFiles)
################################################################################
### LuaSocketRestrictions
	set(test_name LuaSocketRestrictions)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/lib/luasocket/TestRestriction.cpp"
			"${ENGINE_SOURCE_DIR}/lib/luasocket/src/restrictions.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DTEST")

################################################################################
### CREG
	add_test(NAME testCreg COMMAND ${CMAKE_BINARY_DIR}/spring-headless${CMAKE_EXECUTABLE_SUFFIX} --test-creg)

################################################################################
### CREG LoadSave
	set(test_name LoadSave)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/LoadSave/testCregLoadSave.cpp"
			"${ENGINE_SOURCE_DIR}/System/creg/Serializer.cpp"
			"${ENGINE_SOURCE_DIR}/System/creg/VarTypes.cpp"
			"${ENGINE_SOURCE_DIR}/System/creg/creg.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_REGEX_LIBRARY}
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" -"DTEST")

################################################################################
### UnitSync
	set(test_name UnitSync)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/unitsync/testUnitSync.cpp"
			${test_Log_sources}
		)

	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${CMAKE_DL_LIBS}
			unitsync
		)

	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")
	add_dependencies(test_${test_name} springcontent.sdz)

################################################################################
### ThreadPool
	set(test_name ThreadPool)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/testThreadPool.cpp"
			"${ENGINE_SOURCE_DIR}/System/ThreadPool.cpp"
			"${ENGINE_SOURCE_DIR}/System/Misc/SpringTime.cpp"
			"${ENGINE_SOURCE_DIR}/System/UnsyncedRNG.cpp"
			"${ENGINE_SOURCE_DIR}/System/Platform/CpuID.cpp"
			"${ENGINE_SOURCE_DIR}/System/Platform/Threading.cpp"
			${test_Log_sources}
		)
	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${Boost_CHRONO_LIBRARY_WITH_RT}
			${Boost_SYSTEM_LIBRARY}
			${WINMM_LIBRARY}
		)
if(NOT WIN32)
# FIXME: sometimes fails on windows
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "-DTHREADPOOL -DUNITSYNC")
endif()

################################################################################
### EventClient
	set(test_name EventClient)
	Set(test_src
			"${CMAKE_CURRENT_SOURCE_DIR}/engine/System/EventClient.cpp"
			${test_Log_sources}
		)
	set(test_libs
			${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
		)
	add_spring_test(${test_name} "${test_src}" "${test_libs}" "")

################################################################################
EndIf (NOT Boost_FOUND)

add_subdirectory(headercheck)

=== AI/Skirmish/CMakeLists.txt ===
### Skirmish AIs
#
# Functions and macros defined in this file:
# * SkirmishAIMessage
#

add_definitions(-DBUILDING_SKIRMISH_AI)

set(SKIRMISH_SRC            "${CMAKE_CURRENT_SOURCE_DIR}")

# Print a message, but only if we are allowed to speak.
macro    (SkirmishAIMessage type msg)
	if    (NOT SKIRMISHAI_FIND_QUIETLY)
		message(STATUS "${msg}")
	endif (NOT SKIRMISHAI_FIND_QUIETLY)
endmacro (SkirmishAIMessage typemsg)


# Add all Skirmish AI submodules
GetListOfSubModules(SKIRMISH_AI_DIRS)
set(DEPS_AI_SKIRMISH "")
foreach    (skirmishAIDir ${SKIRMISH_AI_DIRS})
	Add_Subdirectory(${skirmishAIDir})
	list(APPEND DEPS_AI_SKIRMISH ${skirmishAIDir})
endforeach (skirmishAIDir)
MakeGlobal(DEPS_AI_SKIRMISH)

=== rts/ExternalAI/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
SET(sources_engine_ExternalAI
		"${CMAKE_CURRENT_SOURCE_DIR}/AICallback.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AICheats.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceKey.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceLibrary.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AIInterfaceLibraryInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AILibraryManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AISCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/EngineOutHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/IAILibraryManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LuaAIImplHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SAIInterfaceCallbackImpl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SSkirmishAICallbackImpl.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIKey.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAILibrary.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAILibraryInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SkirmishAIWrapper.cpp"
		PARENT_SCOPE
	)

=== rts/Game/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp" | sort
MakeGlobalVar(sources_engine_Game
		"${CMAKE_CURRENT_SOURCE_DIR}/Action.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/AviVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Benchmark.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/CameraController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FPSController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/FreeController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OrbitController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/OverviewController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/RotOverheadController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/SmoothController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Camera/TWController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CameraHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ChatMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ClientSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/CommandMessage.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Console.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/ConsoleHistory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/DummyVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/FPSUnitController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Game.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameData.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameHelper.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameSetup.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GameVersion.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GlobalUnsynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GUI/PlayerRoster.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/GUI/PlayerRosterDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/IVideoCapturing.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDraw.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/InMapDrawModel.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/LoadScreen.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/Player.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerBase.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/PlayerStatistics.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Players/TeamController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/PreGame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnitsHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SelectedUnitsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/SyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/TraceRay.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CommandColors.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/CursorIcons.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/EndGameBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GameSetupDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/GuiHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/HwMouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InfoConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/InputReceiver.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyBindings.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeyCodes.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/KeySet.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MiniMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseCursor.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/MouseHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ProfileDrawer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/QuitBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ResourceBar.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/SelectionKeyHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/ShareBox.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/StartPosSelecter.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/TooltipConsole.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UI/UnitTracker.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/UnsyncedGameCommands.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WaitCommandsAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/WordCompletion.cpp"
	)

=== rts/Sim/CMakeLists.txt ===

# This list was created using this *nix shell command:
# > find . -name "*.cpp"" | sort
add_library(engineSim STATIC
		"${CMAKE_CURRENT_SOURCE_DIR}/Features/Feature.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Features/FeatureDef.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Features/FeatureHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/AirBaseHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/AllyTeam.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/CategoryHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/CollisionHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/CollisionVolume.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/CommonDefHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/DamageArray.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/DamageArrayHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/DefinitionTag.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/GeometricObjects.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/GlobalSynced.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/GroundBlockingObjectMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/InterceptHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/LosHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/LosMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/ModInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/NanoPieceCache.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/QuadField.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/RadarHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/Resource.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/ResourceHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/ResourceMapAnalyzer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/SideParser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/SimObjectIDPool.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/SmoothHeightMesh.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/Team.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/TeamBase.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/TeamHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/TeamStatistics.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Misc/Wind.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/AAirMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/StrafeAirMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/ClassicGroundMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/GroundMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveDefHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveMath/GroundMoveMath.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveMath/HoverMoveMath.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveMath/MoveMath.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveMath/ShipMoveMath.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/MoveTypeFactory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/ScriptMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/StaticMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/MoveTypes/HoverAirMoveType.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Objects/SolidObject.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Objects/SolidObjectDef.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Objects/WorldObject.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/IPathFinder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathCache.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathEstimator.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathFinder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathFinderDef.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathFlowMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathHeatMap.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/Default/PathManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/QTPFS/Node.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/QTPFS/NodeLayer.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/QTPFS/PathCache.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/QTPFS/PathSearch.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/QTPFS/PathManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/IPathController.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Path/IPathManager.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/ExpGenSpawner.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/ExplosionListener.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/ExplosionGenerator.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/FireProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/FlareProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/PieceProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Projectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/ProjectileHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/ProjectileFunctors.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/BitmapMuzzleFlame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/BubbleProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/DirtProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/ExploSpikeProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/FlyingPiece.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/GenericParticleProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/GeoSquareProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/GeoThermSmokeProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/GfxProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/HeatCloudProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/MuzzleFlame.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/RepulseGfx.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/SimpleParticleSystem.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/ShieldProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/SmokeProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/SmokeProjectile2.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/SmokeTrailProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/SpherePartProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/TracerProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/WakeProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/Unsynced/WreckProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/BeamLaserProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/EmgProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/ExplosiveProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/FireBallProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/FlameProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/LargeBeamLaserProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/LaserProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/LightningProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/MissileProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/StarburstProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/TorpedoProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/WeaponProjectile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Projectiles/WeaponProjectiles/WeaponProjectileFactory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/BuildInfo.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/AirCAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/BuilderCAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/Command.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/CommandAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/FactoryCAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/MobileCAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/CommandAI/TransportCAI.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Groups/Group.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Groups/GroupHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/CobEngine.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/CobFile.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/CobInstance.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/CobScriptNames.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/CobThread.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/LuaScriptNames.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/LuaUnitScript.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/NullUnitScript.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/UnitScript.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/UnitScriptEngine.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Scripts/UnitScriptFactory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/Unit.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitDef.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitDefHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitLoader.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitSet.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitTypes/Builder.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitTypes/Building.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitTypes/ExtractorBuilding.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitTypes/Factory.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Units/UnitTypes/TransportUnit.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/BeamLaser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/BombDropper.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/Cannon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/DGunWeapon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/EmgCannon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/FlameThrower.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/LaserCannon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/LightningCannon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/MeleeWeapon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/MissileLauncher.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/NoWeapon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/PlasmaRepulser.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/Rifle.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/StarburstLauncher.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/TorpedoLauncher.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/Weapon.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/WeaponDef.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/WeaponDefHandler.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/Weapons/WeaponLoader.cpp"
	)

include_directories(${SDL2_INCLUDE_DIR})

get_property(SPRING_SIM_LIBRARIES TARGET engineSim PROPERTY LOCATION)
if( CMAKE_COMPILER_IS_GNUCXX)
	# FIXME: hack to avoid linkers to remove not referenced symbols. required because of
	# http://springrts.com/mantis/view.php?id=4511
	MakeGlobalVar(SPRING_SIM_LIBRARIES "-Wl,-whole-archive ${SPRING_SIM_LIBRARIES} -Wl,-no-whole-archive")
else()
	MakeGlobalVar(SPRING_SIM_LIBRARIES "${SPRING_SIM_LIBRARIES}")
endif()

=== rts/builds/CMakeLists.txt ===
### builds
#
# Macros and functions defined in this file:
# * CreateEngineBuildAndInstallTarget
#

Include_Directories(${CMAKE_BINARY_DIR}/src-generated/engine)

# Only install the given engine target executable & dependencies
# example:
# 	CreateEngineBuildAndInstallTarget(headless)
# ->
# 	make spring-headless
# 	make install-spring-headless
macro    (CreateEngineBuildAndInstallTarget targetName)
	# relative source path, eg: "rts/builds/default"
	file(RELATIVE_PATH relSrcDirPath ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

	set(myBuildTarget spring-${targetName})
	set(${targetName}-Deps
			engine-${targetName}
			basecontent
			unitsync
			${DEPS_AI_ALL}
		)
	if (CREATE_MAN_PAGES)
		LIST(APPEND ${targetName}-Deps manpages)
	endif()
	if (userdoc_INSTALL_HTML)
		LIST(APPEND ${targetName}-Deps userdocs)
	endif()

	# Create a custom meta build target
	add_custom_target(${myBuildTarget}
		WORKING_DIRECTORY
			"${CMAKE_BINARY_DIR}"
		COMMENT
			"  ${myBuildTarget}: Building all dependencies ..." VERBATIM
		)
	# This also works for custom targets
	add_dependencies(${myBuildTarget} ${${targetName}-Deps})
	Add_Dependencies(engine-${targetName} generateVersionFiles basecontent)

	# Only install spring-<targetName> executable & dependencies
	set(${targetName}-InstallDirs
			"${relSrcDirPath}"
			"doc"
			"tools/unitsync"
			"cont"
			"rts/lib/luasocket"
		)
	If    (NOT "${AI_TYPES}" STREQUAL "NONE")
		Set(${targetName}-InstallDirs ${${targetName}-InstallDirs} "AI")
	EndIf (NOT "${AI_TYPES}" STREQUAL "NONE")

	CreateInstallTarget(spring-${targetName} myBuildTarget ${targetName}-InstallDirs)

	# allow easy switching of the default engine
	if    (${targetName} STREQUAL "legacy")
		# Create shortcuts
		# * make spring
		# * make install-spring
		message(STATUS "Using ${targetName} as default engine")
		add_dependencies(spring spring-${targetName}) # This also works for custom targets
		add_dependencies(install-spring install-spring-${targetName}) # This also works for custom targets
		set_target_properties(engine-${targetName} PROPERTIES OUTPUT_NAME "spring")
	else()
		set_target_properties(engine-${targetName} PROPERTIES OUTPUT_NAME "spring-${targetName}")
	endif ()
endmacro (CreateEngineBuildAndInstallTarget targetName)


# This allows us to disable each build type individually at configure stage.
Macro    (AddEngineBuild build)
	option(BUILD_spring-${build} "Configure the spring-${build} target." TRUE)
	If     (BUILD_spring-${build})
		Add_Subdirectory(${build})
	EndIf  ()
EndMacro (AddEngineBuild)

# add default dummy target which is used later on
add_custom_target(spring WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")
add_custom_target(install-spring WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")

if    (NOT HEADLESS_SYSTEM)
	### Add icon and manifest to exe using windres
	IF    (WIN32 AND MINGW)
		SET(ENGINE_ICON "${ENGINE_SRC_ROOT_DIR}/icon.rc")
	ENDIF (WIN32 AND MINGW)
	AddEngineBuild(legacy)
endif (NOT HEADLESS_SYSTEM)

AddEngineBuild(dedicated)
AddEngineBuild(headless)

=== rts/lib/CMakeLists.txt ===

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/rts)

ADD_SUBDIRECTORY(lua)
ADD_SUBDIRECTORY(luasocket)
ADD_SUBDIRECTORY(7z)
ADD_SUBDIRECTORY(minizip)
ADD_SUBDIRECTORY(streflop)
ADD_SUBDIRECTORY(headlessStubs)
ADD_SUBDIRECTORY(assimp)

if    (NOT HEADLESS_SYSTEM)

	if    (USE_LIBSQUISH)
		ADD_SUBDIRECTORY(rg-etc1)
		ADD_SUBDIRECTORY(squish)
	endif (USE_LIBSQUISH)
endif (NOT HEADLESS_SYSTEM)

=== AI/Interfaces/Java/CMakeLists.txt ===
### Java AI Interface
#
# Global variables set in this file:
# * BUILD_Java_AIINTERFACE
# * Java_AIINTERFACE_VERS
# * Java_AIINTERFACE_TARGET
#
# Functions and macros defined in this file:
# * ConfigureJavaSkirmishAI
#

#enable_language(Java)


################################################################################
### BEGINN: MACROS_AND_FUNCTIONS
# Define macros and functions to be used in this file and by Java Skirmish AIs

# includes rts/build/cmake/UtilJava.cmake
INCLUDE(UtilJava)

macro    (ConfigureJavaSkirmishAI wrapperNames)
	ConfigureCMakeOrMavenJavaSkirmishAI(FALSE "${wrapperNames}")
endmacro (ConfigureJavaSkirmishAI requireMaven wrapperNames)

macro    (ConfigureMavenJavaSkirmishAI wrapperNames)
	ConfigureCMakeOrMavenJavaSkirmishAI(TRUE  "${wrapperNames}")
endmacro (ConfigureMavenJavaSkirmishAI wrapperNames)

# Java Skirmish AI configuration macro.
# This will be called from Java AIs at AI/Skirmish/*/CMakeLists.txt.
# If Maven is installed and AI/Skirmish/*/pom.xml exists,
# this macro will try to build the AI through Maven.
# If requireMaven is TRUE, we will only attemp to build the
# AI through Maven, and disable building of the AI if Maven
# is not available.
macro    (ConfigureCMakeOrMavenJavaSkirmishAI requireMaven wrapperNames)
	# Assemble meta data
	set(myDir            "${CMAKE_CURRENT_SOURCE_DIR}")
	GetLastPathPart(dirName ${myDir})
	set(myName          "${dirName}")
	set(myJarFile       "SkirmishAI")
	set(myBinJarFile    "${myJarFile}.jar")
	set(mySrcJarFile    "${myJarFile}-src.jar")
	set(myJLibDir       "${myDir}/data/jlib")
	GetVersionPlusDepFile(myVersion myVersionDepFile)
	set(myTarget        "${myName}")
	set(myInstLibsDir   "${SKIRMISH_AI_LIBS}/${myName}/${myVersion}")
	set(myInstDataDir   "${SKIRMISH_AI_DATA}/${myName}/${myVersion}")
	# CMAKE_CURRENT_BINARY_DIR: .../spring-build-dir/AI/Skirmish/${myName}
	set(myBuildDir      "${CMAKE_CURRENT_BINARY_DIR}")

	# Check if the user wants to compile the AI
	Set(BUILD_THIS_SKIRMISHAI FALSE)
	if    (BUILD_Java_AIINTERFACE AND NOT myName MATCHES "${AI_EXCLUDE_REGEX}")
		set(BUILD_THIS_SKIRMISHAI TRUE)
		If    (requireMaven)
			Find_Package(Maven)
			If    (NOT MAVEN_FOUND)
				Set(BUILD_THIS_SKIRMISHAI FALSE)
				Message(WARNING "${myName} Skirmish AI requires Maven to build, but Maven 2 (or later) was not found.")
			EndIf (NOT MAVEN_FOUND)
		EndIf (requireMaven)
	endif (BUILD_Java_AIINTERFACE AND NOT myName MATCHES "${AI_EXCLUDE_REGEX}")
	If    (NOT BUILD_THIS_SKIRMISHAI)
		Message("warning: ${myName} Skirmish AI will not be built!")
	EndIf (NOT BUILD_THIS_SKIRMISHAI)

	# Compile and install
	if    (BUILD_THIS_SKIRMISHAI)
		file(MAKE_DIRECTORY "${myBuildDir}/jlib")

		Find_Package(Maven)
		IsMavenProject(${myDir} isMavenProject)
		set(configureMavenProject FALSE)
		if    (isMavenProject)
			if    (MAVEN_FOUND)
				set(configureMavenProject TRUE)
			else  (MAVEN_FOUND)
				Message("warning: ${myName} Skirmish AI has a Maven Project file, but Maven 2 (or later) was not found; Using default configuration.")
			endif (MAVEN_FOUND)
		endif (isMavenProject)

		set(configString "default")
		if    (configureMavenProject)
			set(configString "Maven")
		endif (configureMavenProject)
		SkirmishAIMessage(STATUS "Found Skirmish AI: ${myName} ${myVersion} (config: ${configString})")

		# Assemble project generated targets (and their libraries) we depend on
		set(myDependTargets  "${Java_AIINTERFACE_TARGET}")
		set(myDependLibFiles "${Java_AIINTERFACE_JAR_BIN}")
		foreach    (wrapperName ${wrapperNames})
			set(myDependTargets  ${myDependTargets}  "${${wrapperName}_AIWRAPPER_TARGET}")
			set(myDependLibFiles ${myDependLibFiles} "${${wrapperName}_AIWRAPPER_JAR_BIN}")
		endforeach (wrapperName)
		set_source_files_properties(${myDependLibFiles} PROPERTIES GENERATED TRUE)

		# find java source root
		if     (EXISTS "${myDir}/src/main/java")
			# default Maven source dir
			set(mySourceDir          "${myDir}/src/main/java")
		elseif (EXISTS "${myDir}/src")
			# simple java source dir path
			set(mySourceDir          "${myDir}/src")
		else   (EXISTS "${myDir}/src/main/java")
			message(SEND_ERROR "No sources dir found for Skirmish AI: ${myName}")
		endif  (EXISTS "${myDir}/src/main/java")

		# Create a list of all the AIs source files (for compiling)
		file(GLOB_RECURSE mySources RELATIVE "${mySourceDir}" FOLLOW_SYMLINKS "${mySourceDir}/*.java")
		# Create a list of all the AIs source files (for dependency tracking)
		file(GLOB_RECURSE mySourcesDep FOLLOW_SYMLINKS "${mySourceDir}/*.java")

		set_source_files_properties("${myBuildDir}/${myBinJarFile}" PROPERTIES GENERATED TRUE)
		set_source_files_properties("${myBuildDir}/${mySrcJarFile}" PROPERTIES GENERATED TRUE)


		if    (configureMavenProject)
			# The Maven Project has to make sure these files get created:
			# ${my.build.dir}/SkirmishAI.jar
			# ${my.build.dir}/SkirmishAI-src.jar (optional)
			file(RELATIVE_PATH myBuildDirRel "${myDir}" "${myBuildDir}")
			set(MVN_ATTRIBUTES
				${MVN_ATTRIBUTES_DEFAULT}
				"-P" "as-spring-subproject" # enable special profile
				"-Dmy.build.dir=${myBuildDirRel}"
				"-Dmy.version=${myVersion}"
				)
			set(MVN_PHASE "package")
			#set(MVN_PHASE "help:effective-pom") # use this for debug purposes
			add_custom_command(
				OUTPUT
					"${myBuildDir}/${myBinJarFile}"
				COMMAND "${MVN_BIN}"
					"${MVN_PHASE}" ${MVN_ATTRIBUTES}
				DEPENDS
					${myDependLibFiles}
					${mySourcesDep}
				WORKING_DIRECTORY
					"${myDir}"
				COMMENT
					"  ${myTarget}: Running Maven ${MVN_PHASE} phase" VERBATIM
				)
			Set(myDependTargets  ${myDependTargets} "${Java_AIINTERFACE_TARGET_MVN_INSTALL}")
			ForEach    (wrapperName ${wrapperNames})
				Set(myDependTargets  ${myDependTargets} "${${wrapperName}_AIWRAPPER_TARGET_MVN_INSTALL}")
			EndForEach (wrapperName)
			add_custom_target(${myTarget} ALL DEPENDS "${myBuildDir}/${myBinJarFile}" ${myVersionDepFile})
			add_dependencies(${myTarget} ${myDependTargets})
		else  (configureMavenProject)
			# If main Java package is "my.ai.pkg", this has to be set to "my".
			GetFirstSubDirName(firstSrcSubDir ${mySourceDir})
			set(myJavaPkgFirstPart "${firstSrcSubDir}")

			# Assemble additional meta data
			set(myBinaryTarget "${myTarget}-BIN")
			set(mySourceTarget "${myTarget}-SRC")
			set(myJavaBuildDir "${myBuildDir}/classes")

			add_custom_target(${myBinaryTarget}
				DEPENDS "${myBuildDir}/${myBinJarFile}")
			add_dependencies(${myBinaryTarget} ${myDependTargets})

			add_custom_target(${mySourceTarget}
				DEPENDS "${myBuildDir}/${mySrcJarFile}")

			add_custom_target(${myTarget} ALL DEPENDS ${myVersionDepFile})
			add_dependencies(${myTarget} ${myBinaryTarget} ${mySourceTarget})

			# Create our full Java class-path
			CreateClasspath(myJavaLibs ${myJLibDir})
			ConcatClasspaths(myClassPath "${CLASSPATH_Java_AIINTERFACE}" "${myJavaLibs}")
			foreach    (wrapperName ${wrapperNames})
				ConcatClasspaths(myClassPath "${myClassPath}" "${${wrapperName}_AIWRAPPER_JAR_CLASSPATH}")
			endforeach (wrapperName)

			# Locate the manifest file
			FindManifestFile("${myDir}" myManifestFile)
			if    (myManifestFile)
				set(myBinJarArgs "cmf" "${myManifestFile}")
			else  (myManifestFile)
				set(myBinJarArgs "cf")
			endif (myManifestFile)

			# Write list of source files to an arg-file
			set(mySrcArgFile "${myBuildDir}/sourceFiles.txt")
			if    (EXISTS "${mySrcArgFile}")
				file(REMOVE "${mySrcArgFile}")
			endif (EXISTS "${mySrcArgFile}")
			set(mySrcArgFile "${myBuildDir}/sourceFiles.txt")
			foreach    (srcFile ${mySources})
				file(APPEND "${mySrcArgFile}" "\"${srcFile}\"\n")
			endforeach (srcFile)

			# Compile and pack the library
			add_custom_command(
				OUTPUT
					"${myBuildDir}/${myBinJarFile}"
				DEPENDS
					${myDependLibFiles}
					${mySourcesDep}
				COMMAND "${CMAKE_COMMAND}"
					"-E" "remove_directory" "${myJavaBuildDir}"
				COMMAND "${CMAKE_COMMAND}"
					"-E" "make_directory" "${myJavaBuildDir}"
				COMMAND "${JAVA_COMPILE}"
					"${JAVA_COMPILE_FLAG_CONDITIONAL}"
					"-Xlint:deprecation"
					"-cp" "${myClassPath}"
					"-d" "${myJavaBuildDir}"
					"@${mySrcArgFile}"
				COMMAND "${JAVA_ARCHIVE}"
					${myBinJarArgs} "${myBuildDir}/${myBinJarFile}"
					"-C" "${myJavaBuildDir}" "${myJavaPkgFirstPart}"
				WORKING_DIRECTORY
					"${mySourceDir}"
				COMMENT
					"  ${myTarget}: Compiling sources and packing library ${myBinJarFile}" VERBATIM
				)

			# Pack the sources
			add_custom_command(
				OUTPUT
					"${myBuildDir}/${mySrcJarFile}"
				COMMAND "${JAVA_ARCHIVE}"
					"cf" "${myBuildDir}/${mySrcJarFile}"
					"-C" "${mySourceDir}" "${myJavaPkgFirstPart}"
				DEPENDS
					${mySourcesDeps}
				WORKING_DIRECTORY
					"${mySourceDir}"
				COMMENT
					"  ${myTarget}: Creating sources archive ${mySrcJarFile}" VERBATIM
				)
		endif (configureMavenProject)

		# Install the data files
		install(DIRECTORY "${myDir}/data/"                 DESTINATION ${myInstDataDir})
		# Install the library
		install(FILES    "${myBuildDir}/${myBinJarFile}"   DESTINATION ${myInstDataDir})
		# Install the sources archive (optional)
		install(FILES    "${myBuildDir}/${mySrcJarFile}"   DESTINATION ${myInstDataDir}/jlib OPTIONAL)

		# Install files generated/downloaded during buildtime
		install(DIRECTORY "${myBuildDir}/jlib/"            DESTINATION ${myInstDataDir}/jlib)
		if    (EXISTS "${myBuildDir}/resources")
			install(DIRECTORY "${myBuildDir}/resources/"   DESTINATION ${myInstDataDir}/resources)
		endif (EXISTS "${myBuildDir}/resources")
		if    (EXISTS "${myBuildDir}/config")
			install(DIRECTORY "${myBuildDir}/config/"      DESTINATION ${myInstDataDir}/config)
		endif (EXISTS "${myBuildDir}/config")
		if    (EXISTS "${myBuildDir}/script")
			install(DIRECTORY "${myBuildDir}/script/"      DESTINATION ${myInstDataDir}/script)
		endif (EXISTS "${myBuildDir}/script")

		# Install special script and config files
		if    (EXISTS "${myDir}/src/main/groovy")
			install(DIRECTORY "${myDir}/src/main/groovy/"  DESTINATION ${myInstDataDir}/script)
		endif (EXISTS "${myDir}/src/main/groovy")
		if    (EXISTS "${myDir}/src/main/ruby")
			install(DIRECTORY "${myDir}/src/main/ruby/"    DESTINATION ${myInstDataDir}/script)
		endif (EXISTS "${myDir}/src/main/ruby")
		if    (EXISTS "${myDir}/src/main/bsh")
			install(DIRECTORY "${myDir}/src/main/bsh/"     DESTINATION ${myInstDataDir}/script)
		endif (EXISTS "${myDir}/src/main/bsh")
		if    (EXISTS "${myDir}/src/main/config")
			install(DIRECTORY "${myDir}/src/main/config/"  DESTINATION ${myInstDataDir}/config)
		endif (EXISTS "${myDir}/src/main/config")

		if    (NOT configureMavenProject)
			# Install jars of wrappers
			foreach    (wrapperName ${wrapperNames})
				# Install the wrappers main jar
				install(FILES "${${wrapperName}_AIWRAPPER_JAR_BIN}" DESTINATION ${myInstDataDir}/jlib)
				set(wrapperJLibDir "${CMAKE_SOURCE_DIR}/AI/Wrappers/${wrapperName}/jlib")
				# Install the wrappers java libs, if there are any
				if    (EXISTS ${wrapperJLibDir})
					install(DIRECTORY "${wrapperJLibDir}/" DESTINATION ${myInstDataDir}/jlib)
				endif (EXISTS ${wrapperJLibDir})
			endforeach (wrapperName)
		endif (NOT configureMavenProject)
	endif (BUILD_THIS_SKIRMISHAI)
endmacro (ConfigureCMakeOrMavenJavaSkirmishAI requireMaven wrapperNames)


### END: MACROS_AND_FUNCTIONS
################################################################################


set(myName               "Java")
set(myDir                "${CMAKE_CURRENT_SOURCE_DIR}")
set(mySourceDirRel       "src/main")
set(myJavaSourceDirRel   "src/main/java")
set(myNativeSourceDirRel "src/main/native")
set(myPkgFirstPart       "com")
set(myPkg                "${myPkgFirstPart}/springrts/ai")


# Check if the user wants to compile the interface
if    ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "JAVA")
	set(AI_TYPES_JAVA TRUE)
else  ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "JAVA")
	set(AI_TYPES_JAVA FALSE)
endif ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "JAVA")

=== AI/Skirmish/KAIK/CMakeLists.txt ===
### Generic native Skirmish AI config
#

if(NOT WIN32)
	add_definitions(-DLUA_USE_POSIX)
endif()

GetNativeSourcesRecursive(luaSources "${CMAKE_SOURCE_DIR}/rts/lib/lua/src" "")

set(mySourceDirRel         "") # Common values are "" or "src"
set(additionalSources      ${luaSources} ${CMAKE_SOURCE_DIR}/rts/System/Util)
## FIXME:
##     "undefined symbol: _ZTIN4creg18IMemberRegistratorE"
##     ("typeinfo for creg::IMemberRegistrator") on dlopen
##     after Spring b1152310caff2a928635f6f1d9e6fe936076176f
##     and/or KAIK 000c7bf2659ceb4d50666cb32b342bcf26ada243
## set(additionalCompileFlags "-DUSING_CREG")
## set(additionalLibraries    ${LegacyCpp_Creg_AIWRAPPER_TARGET})
set(additionalLibraries    ${LegacyCpp_AIWRAPPER_TARGET} CUtils)
include_directories("${CMAKE_SOURCE_DIR}/rts/lib/lua/include/")
include_directories("${CMAKE_SOURCE_DIR}/rts/lib/lua/src/")
include_directories("${CMAKE_SOURCE_DIR}/rts/lib/streflop/")

ConfigureNativeSkirmishAI(mySourceDirRel additionalSources additionalCompileFlags additionalLibraries)

=== AI/Wrappers/Cpp/CMakeLists.txt ===
### (New) C++ AI Wrapper
#
# Global variables set in this file:
# * BUILD_Cpp_AIWRAPPER
# * Cpp_AIWRAPPER_TARGET
#


set(myName         "Cpp")
set(mySourceDirRel "src")


# Check if the user wants to compile the wrapper
if    ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "NATIVE")
	set(AIWRAPPERS_NATIVE TRUE)
else  ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "NATIVE")
	set(AIWRAPPERS_NATIVE FALSE)
endif ("${AI_TYPES}" STREQUAL "ALL" OR "${AI_TYPES}" STREQUAL "NATIVE")


# Check dependencies of the wrapper are met
if    (AIWRAPPERS_NATIVE AND AWK_FOUND AND NOT myName MATCHES "${AI_EXCLUDE_REGEX}")
	SetGlobal(BUILD_${myName}_AIWRAPPER TRUE)
else  (AIWRAPPERS_NATIVE AND AWK_FOUND AND NOT myName MATCHES "${AI_EXCLUDE_REGEX}")
	SetGlobal(BUILD_${myName}_AIWRAPPER FALSE)
	message ("warning: (New) C++ AI Wrapper will not be built!")
endif (AIWRAPPERS_NATIVE AND AWK_FOUND AND NOT myName MATCHES "${AI_EXCLUDE_REGEX}")


# Build
if    (BUILD_${myName}_AIWRAPPER)
	set(myDir        "${CMAKE_CURRENT_SOURCE_DIR}")
	GetLastPathPart(dirName ${myDir})
	set(myName       "${dirName}")
	set(myTarget     "${myName}-AIWrapper")
	set(myGenTarget  "${myTarget}-generateSources")
	MakeAbsolute(mySourceDir "${myDir}" "${mySourceDirRel}")

	AIWrapperMessage(STATUS "Found AI Wrapper: ${myTarget}")

	SetGlobal(${myName}_AIWRAPPER_TARGET      ${myTarget})


	# Build static library
	set(myAwkScriptsDir            "${myDir}/bin")
	set(commonAwkScriptsDir        "${CMAKE_SOURCE_DIR}/AI/Wrappers/CUtils/bin")
	set(myGeneratedSourceDir       "${CMAKE_CURRENT_BINARY_DIR}/src-generated")
	set(springSourceDir            "${PROJECT_SOURCE_DIR}")
	set(springAIInterfaceSourceDir "${springSourceDir}/rts/ExternalAI/Interface")

	set(${myName}_AIWRAPPER_INCLUDE_DIRS "${mySourceDir}" "${myGeneratedSourceDir}")
	MakeGlobal(${myName}_AIWRAPPER_INCLUDE_DIRS)

	set(mySources
		"${mySourceDir}/AIEvent.cpp"
		"${mySourceDir}/AIFloat3.cpp"
		"${mySourceDir}/AIColor.cpp"
		"${mySourceDir}/AIException.cpp"
		"${mySourceDir}/CallbackAIException.cpp"
		"${mySourceDir}/EventAIException.cpp"
		)

	set(myGeneratedCombineSources
		${myGeneratedSourceDir}/CombinedCallbackBridge.c)
	set(myGeneratedWrapperSources
		${myGeneratedSourceDir}/AbstractCamera.cpp
		${myGeneratedSourceDir}/AbstractCheats.cpp
		${myGeneratedSourceDir}/AbstractCommand.cpp
		${myGeneratedSourceDir}/AbstractCommandDescription.cpp
		${myGeneratedSourceDir}/AbstractDamage.cpp
		${myGeneratedSourceDir}/AbstractDataDirs.cpp
		${myGeneratedSourceDir}/AbstractDrawer.cpp
		${myGeneratedSourceDir}/AbstractEconomy.cpp
		${myGeneratedSourceDir}/AbstractEngine.cpp
		${myGeneratedSourceDir}/AbstractFeature.cpp
		${myGeneratedSourceDir}/AbstractFeatureDef.cpp
		${myGeneratedSourceDir}/AbstractFigure.cpp
		${myGeneratedSourceDir}/AbstractFile.cpp
		${myGeneratedSourceDir}/AbstractFlankingBonus.cpp
		${myGeneratedSourceDir}/AbstractGame.cpp
		${myGeneratedSourceDir}/AbstractGameRulesParam.cpp
		${myGeneratedSourceDir}/AbstractGroup.cpp
		${myGeneratedSourceDir}/AbstractGui.cpp
		${myGeneratedSourceDir}/AbstractInfo.cpp
		${myGeneratedSourceDir}/AbstractLine.cpp
		${myGeneratedSourceDir}/AbstractLog.cpp
		${myGeneratedSourceDir}/AbstractLua.cpp
		${myGeneratedSourceDir}/AbstractMap.cpp
		${myGeneratedSourceDir}/AbstractMod.cpp
		${myGeneratedSourceDir}/AbstractMoveData.cpp
		${myGeneratedSourceDir}/AbstractOOAICallback.cpp
		${myGeneratedSourceDir}/AbstractOptionValues.cpp
		${myGeneratedSourceDir}/AbstractOrderPreview.cpp
		#${myGeneratedSourceDir}/AbstractPath.cpp
		${myGeneratedSourceDir}/AbstractPathDrawer.cpp
		${myGeneratedSourceDir}/AbstractPathing.cpp
		${myGeneratedSourceDir}/AbstractPoint.cpp
		${myGeneratedSourceDir}/AbstractResource.cpp
		${myGeneratedSourceDir}/AbstractRoots.cpp
		${myGeneratedSourceDir}/AbstractShield.cpp
		${myGeneratedSourceDir}/AbstractSkirmishAI.cpp
		${myGeneratedSourceDir}/AbstractSkirmishAIs.cpp
		${myGeneratedSourceDir}/AbstractTeam.cpp
		${myGeneratedSourceDir}/AbstractTeamRulesParam.cpp
		${myGeneratedSourceDir}/AbstractTeams.cpp
		${myGeneratedSourceDir}/AbstractUnit.cpp
		${myGeneratedSourceDir}/AbstractUnitRulesParam.cpp
		${myGeneratedSourceDir}/AbstractUnitDef.cpp
		${myGeneratedSourceDir}/AbstractVersion.cpp
		${myGeneratedSourceDir}/AbstractWeaponDef.cpp
		${myGeneratedSourceDir}/AbstractWeaponMount.cpp
		${myGeneratedSourceDir}/StubCamera.cpp
		${myGeneratedSourceDir}/StubCheats.cpp
		${myGeneratedSourceDir}/StubCommand.cpp
		${myGeneratedSourceDir}/StubCommandDescription.cpp
		${myGeneratedSourceDir}/StubDamage.cpp
		${myGeneratedSourceDir}/StubDataDirs.cpp
		${myGeneratedSourceDir}/StubDrawer.cpp
		${myGeneratedSourceDir}/StubEconomy.cpp
		${myGeneratedSourceDir}/StubEngine.cpp
		${myGeneratedSourceDir}/StubFeature.cpp
		${myGeneratedSourceDir}/StubFeatureDef.cpp
		${myGeneratedSourceDir}/StubFigure.cpp
		${myGeneratedSourceDir}/StubFile.cpp
		${myGeneratedSourceDir}/StubFlankingBonus.cpp
		${myGeneratedSourceDir}/StubGame.cpp
		${myGeneratedSourceDir}/StubGameRulesParam.cpp
		${myGeneratedSourceDir}/StubGroup.cpp
		${myGeneratedSourceDir}/StubGui.cpp
		${myGeneratedSourceDir}/StubInfo.cpp
		${myGeneratedSourceDir}/StubLine.cpp
		${myGeneratedSourceDir}/StubLog.cpp
		${myGeneratedSourceDir}/StubLua.cpp
		${myGeneratedSourceDir}/StubMap.cpp
		${myGeneratedSourceDir}/StubMod.cpp
		${myGeneratedSourceDir}/StubMoveData.cpp
		${myGeneratedSourceDir}/StubOOAICallback.cpp
		${myGeneratedSourceDir}/StubOptionValues.cpp
		${myGeneratedSourceDir}/StubOrderPreview.cpp
		#${myGeneratedSourceDir}/StubPath.cpp
		${myGeneratedSourceDir}/StubPathDrawer.cpp
		${myGeneratedSourceDir}/StubPathing.cpp
		${myGeneratedSourceDir}/StubPoint.cpp
		${myGeneratedSourceDir}/StubResource.cpp
		${myGeneratedSourceDir}/StubRoots.cpp
		${myGeneratedSourceDir}/StubShield.cpp
		${myGeneratedSourceDir}/StubSkirmishAI.cpp
		${myGeneratedSourceDir}/StubSkirmishAIs.cpp
		${myGeneratedSourceDir}/StubTeam.cpp
		${myGeneratedSourceDir}/StubTeamRulesParam.cpp
		${myGeneratedSourceDir}/StubTeams.cpp
		${myGeneratedSourceDir}/StubUnit.cpp
		${myGeneratedSourceDir}/StubUnitRulesParam.cpp
		${myGeneratedSourceDir}/StubUnitDef.cpp
		${myGeneratedSourceDir}/StubVersion.cpp
		${myGeneratedSourceDir}/StubWeaponDef.cpp
		${myGeneratedSourceDir}/StubWeaponMount.cpp
		${myGeneratedSourceDir}/WrappCamera.cpp
		${myGeneratedSourceDir}/WrappCheats.cpp
		${myGeneratedSourceDir}/WrappCurrentCommand.cpp
		${myGeneratedSourceDir}/WrappDamage.cpp
		${myGeneratedSourceDir}/WrappDataDirs.cpp
		${myGeneratedSourceDir}/WrappDebug.cpp
		${myGeneratedSourceDir}/WrappDrawer.cpp
		${myGeneratedSourceDir}/WrappEconomy.cpp
		${myGeneratedSourceDir}/WrappEngine.cpp
		${myGeneratedSourceDir}/WrappFeature.cpp
		${myGeneratedSourceDir}/WrappFeatureDef.cpp
		${myGeneratedSourceDir}/WrappFigure.cpp
		${myGeneratedSourceDir}/WrappFile.cpp
		${myGeneratedSourceDir}/WrappFlankingBonus.cpp
		${myGeneratedSourceDir}/WrappGame.cpp
		${myGeneratedSourceDir}/WrappGameRulesParam.cpp
		${myGeneratedSourceDir}/WrappGraphDrawer.cpp
		${myGeneratedSourceDir}/WrappGraphLine.cpp
		${myGeneratedSourceDir}/WrappGroup.cpp
		${myGeneratedSourceDir}/WrappGroupSupportedCommand.cpp
		${myGeneratedSourceDir}/WrappGui.cpp
		${myGeneratedSourceDir}/WrappInfo.cpp
		${myGeneratedSourceDir}/WrappLine.cpp
		${myGeneratedSourceDir}/WrappLog.cpp
		${myGeneratedSourceDir}/WrappLua.cpp
		${myGeneratedSourceDir}/WrappMap.cpp
		${myGeneratedSourceDir}/WrappMod.cpp
		${myGeneratedSourceDir}/WrappMoveData.cpp
		${myGeneratedSourceDir}/WrappOOAICallback.cpp
		${myGeneratedSourceDir}/WrappOptionValues.cpp
		${myGeneratedSourceDir}/WrappOrderPreview.cpp
		#${myGeneratedSourceDir}/WrappPath.cpp
		${myGeneratedSourceDir}/WrappPathDrawer.cpp
		${myGeneratedSourceDir}/WrappPathing.cpp
		${myGeneratedSourceDir}/WrappPoint.cpp
		${myGeneratedSourceDir}/WrappResource.cpp
		${myGeneratedSourceDir}/WrappRoots.cpp
		${myGeneratedSourceDir}/WrappShield.cpp
		${myGeneratedSourceDir}/WrappSkirmishAI.cpp
		${myGeneratedSourceDir}/WrappSkirmishAIs.cpp
		${myGeneratedSourceDir}/WrappTeam.cpp
		${myGeneratedSourceDir}/WrappTeamRulesParam.cpp
		${myGeneratedSourceDir}/WrappTeams.cpp
		${myGeneratedSourceDir}/WrappUnit.cpp
		${myGeneratedSourceDir}/WrappUnitRulesParam.cpp
		${myGeneratedSourceDir}/WrappUnitDef.cpp
		${myGeneratedSourceDir}/WrappUnitSupportedCommand.cpp
		${myGeneratedSourceDir}/WrappVersion.cpp
		${myGeneratedSourceDir}/WrappWeaponDef.cpp
		${myGeneratedSourceDir}/WrappWeaponMount.cpp)
	set(myGeneratedSources
		${myGeneratedCombineSources}
		${myGeneratedWrapperSources})
	set_source_files_properties(${myGeneratedSources} PROPERTIES GENERATED TRUE)


	set(commonAwkScriptArgs
		"-v" "SPRING_SOURCE_DIR=${springSourceDir}"
		"-v" "GENERATED_SOURCE_DIR=${myGeneratedSourceDir}"
		"-f" "${commonAwkScriptsDir}/common.awk"
		"-f" "${commonAwkScriptsDir}/commonDoc.awk"
		)

	# 1. Combine Callback & Commands (C->C)
	add_custom_command(
		DEPENDS
			"${commonAwkScriptsDir}/common.awk"
			"${commonAwkScriptsDir}/commonDoc.awk"
			"${myAwkScriptsDir}/combine_wrappCallback.awk"
			"${myAwkScriptsDir}/combine_wrappCommands.awk"
			"${springAIInterfaceSourceDir}/SSkirmishAICallback.h"
			"${springAIInterfaceSourceDir}/AISCommands.h"
		OUTPUT
			"${myGeneratedSourceDir}/CombinedCallbackBridge.h"
			"${myGeneratedSourceDir}/CombinedCallbackBridge.c"
		COMMAND "${CMAKE_COMMAND}"
			"-E" "make_directory" "${myGeneratedSourceDir}"
		COMMAND "${AWK_BIN}"
			${commonAwkScriptArgs}
			"-f" "${myAwkScriptsDir}/combine_wrappCallback.awk"
			"${springAIInterfaceSourceDir}/SSkirmishAICallback.h"
		COMMAND "${AWK_BIN}"
			${commonAwkScriptArgs}
			"-f" "${myAwkScriptsDir}/combine_wrappCommands.awk"
			"${springAIInterfaceSourceDir}/AISCommands.h"
		WORKING_DIRECTORY
			"${myAwkScriptsDir}"
		COMMENT
			"  ${myTarget}: Generating combined C callback wrapper sources ..." VERBATIM)

	# this will regenerate the sources whenever the DEPENDS changes
	add_custom_command(
		DEPENDS
			"${commonAwkScriptsDir}/common.awk"
			"${commonAwkScriptsDir}/commonDoc.awk"
			"${commonAwkScriptsDir}/commonOOCallback.awk"
			"${myAwkScriptsDir}/wrappCallback.awk"
			"${myGeneratedSourceDir}/CombinedCallbackBridge.h"
			"${myGeneratedSourceDir}/CombinedCallbackBridge.c"
		OUTPUT
			${myGeneratedWrapperSources}
		COMMAND "${AWK_BIN}"
			${commonAwkScriptArgs}
			"-f" "${commonAwkScriptsDir}/commonOOCallback.awk"
			"-f" "${myAwkScriptsDir}/wrappCallback.awk"
			"${myGeneratedSourceDir}/CombinedCallbackBridge.h"
		WORKING_DIRECTORY
			"${myAwkScriptsDir}"
		COMMENT
			"  ${myTarget}: Generating C++ Callback wrapper sources" VERBATIM)

	add_custom_target(${myGenTarget} DEPENDS ${myGeneratedSources})
	add_dependencies(generateSources ${myGenTarget})

	# build the static lib
	include_directories(${mySourceDir} ${myGeneratedSourceDir})
	set(myCompleteSources ${mySources} ${myGeneratedSources})
	list(APPEND myCompleteSources ${ai_common_SRC})
	add_library(${myTarget} STATIC ${myCompleteSources})
	Add_Dependencies(${myTarget} generateVersionFiles)
	set_target_properties(${myTarget} PROPERTIES OUTPUT_NAME "${myName}")
endif (BUILD_${myName}_AIWRAPPER)

=== rts/builds/headless/CMakeLists.txt ===
# Place executables and shared libs under "build-dir/",
# instead of under "build-dir/rts/"
# This way, we have the build-dir structure more like the install-dir one,
# which makes testing spring in the builddir easier, eg. like this:
# cd build-dir
# SPRING_DATADIR=$(pwd) ./spring
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

ADD_DEFINITIONS(-DHEADLESS)
ADD_DEFINITIONS(-DNO_SOUND)
ADD_DEFINITIONS(-DBITMAP_NO_OPENGL)
REMOVE_DEFINITIONS(-DAVI_CAPTURING)

include_directories(${OPENAL_INCLUDE_DIR})
IF    (MINGW OR APPLE)
	# Windows:
	# We still need these header files,
	# even if we are not going to link with gl, glu and SDL.
	# We have them available anyway (mingwlibs).
	# OS X:
	# Cocoa requires the SDL libary, whenever the SDL headers are used,
	# due to some #define magic, which is practically impossible to workaround.
	FIND_PACKAGE(OpenGL REQUIRED)
	FIND_PACKAGE(SDL2 REQUIRED)
	INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR})
ELSE  (MINGW OR APPLE)
	# Use a direct copy of the GL and SDL headers,
	# as these may not be available on headless systems.
	INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include)
	INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/SDL2)
ENDIF (MINGW OR APPLE)


# headlessstubs are our stubs that replace libGL, libGLU, libGLEW, libSDL (yes really!)
LIST(APPEND engineHeadlessLibraries headlessStubs)
LIST(APPEND engineHeadlessLibraries ${SPRING_SIM_LIBRARIES})
LIST(APPEND engineHeadlessLibraries engineSystemNet)
LIST(APPEND engineHeadlessLibraries ${engineCommonLibraries})
LIST(APPEND engineHeadlessLibraries engineaGui)
LIST(APPEND engineHeadlessLibraries no-sound)
LIST(APPEND engineHeadlessLibraries engineSim)

INCLUDE_DIRECTORIES(${ENGINE_SRC_ROOT_DIR}/lib/assimp/include)


### Build the executable
ADD_EXECUTABLE(engine-headless ${engineSources} ${ENGINE_ICON})
TARGET_LINK_LIBRARIES(engine-headless no-sound ${engineHeadlessLibraries} no-sound)

IF    (MINGW)
	# To enable console output/force a console window to open
	SET_TARGET_PROPERTIES(engine-headless PROPERTIES LINK_FLAGS "-Wl,-subsystem,console")
ENDIF (MINGW)


### Install the executable
INSTALL(TARGETS engine-headless DESTINATION ${BINDIR})

# Only build & install spring-headless executable & dependencies
# use cases:
# * make spring-headless
# * make install-spring-headless
CreateEngineBuildAndInstallTarget(headless)

=== debian/changelog ===
spring (98.0+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 98.0+dfsg.
  * Declare compliance with Debian Policy 3.9.6.
  * Update VCS browser field to new canonical address.
  * Drop FTBFS-GCC-4.9.patch and cmake3.0.patch. Fixed upstream.
  * Remove unused lintian overrides for missing classpath warning.
  * Override lintian error shlib-with-non-pic-code (only on i386) because those
    files are not shared libraries but AI components of the Spring engine.

 -- Markus Koschany <apo@gambaru.de>  Sat, 11 Oct 2014 22:34:19 +0200

spring (97.0+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 97.0+dfsg.
  * debian/watch: Remove lzma extension, use upstream's gzip compressed
    tarballs and avoid a bug with uscan.
  * Update get-orig-source target for new release.
  * Switch to SDL2. Build-depend on libsdl2-dev.
  * Update sdl-debian.patch for SDL2.
  * Add cmake3.0.patch:
    - Cherry pick upstream commit and support the latest cmake 3.0 release.
      Thanks to Felix Geyer for the report. (Closes: #758259)
  * Update debian/copyright for new release.

 -- Markus Koschany <apo@gambaru.de>  Sat, 16 Aug 2014 22:20:11 +0200

spring (96.0+dfsg-2) unstable; urgency=medium

  * Remove mention of oscpack from debian/copyright.
    - This directory does no longer exist.
  * Add FTBFS-GCC-4.9.patch.
    - Cherry pick upstream workaround to fix FTBFS with GCC 4.9.
      (Closes: #746914)
  * debian/control: Do not suggest libtxc-dxtn0 anymore.
    - This package is now recommended by libgl1-mesa-dri (Closes: #739183)

 -- Markus Koschany <apo@gambaru.de>  Sun, 01 Jun 2014 23:18:17 +0200

=== debian/control ===
Source: spring
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@gambaru.de>
Build-Depends:
 asciidoc,
 bzip2,
 cmake,
 debhelper (>= 9),
 docbook-xml,
 docbook-xsl,
 libboost-all-dev,
 libdevil-dev,
 libfreetype6-dev,
 libglew-dev,
 libogg-dev,
 libopenal-dev,
 libsdl2-dev,
 libvorbis-dev,
 libxcursor-dev,
 p7zip-full,
 python-pygccxml,
 xsltproc,
 zip
Build-Depends-Indep:
 default-jdk,
 libjna-java,
 libvecmath-java
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-games/spring.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/spring.git
Homepage: http://springrts.com

Package: spring
Architecture: amd64 i386
Depends:
 fonts-freefont-otf,
 spring-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 springlobby
Suggests:
 spring-javaai
Description: modern full-3D RTS game engine
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine and the default AI, with no maps,
 mods or rich user interface.

Package: spring-common
Architecture: all
Depends:
 ${misc:Depends}
Description: modern full-3D RTS game engine (common files)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package just includes the game engine's arch independent files, with no
 maps, mods or rich user interface.

Package: spring-dbg
Section: debug
Architecture: amd64 i386
Priority: extra
Depends:
 spring (= ${binary:Version}),
 ${misc:Depends}
Description: modern full-3D RTS game engine (debugging symbols)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package contains the debugging symbols for the spring binaries.

Package: spring-javaai
Architecture: all
Depends:
 default-jre | java7-runtime,
 libjna-java,
 libvecmath-java,
 spring (>= ${source:Version}),
 ${misc:Depends}
Description: modern full-3D RTS game engine (Java AIs)
 Spring is a modern full-3D RTS (Real Time Strategy) game engine originally
 created to bring the gameplay experience of Total Annihilation into 3D.
 Games are played using one of a number of mods.
 .
 This package contains Java based AIs and the spring interface libraries these
 require.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

PKD   := $(abspath $(dir $(MAKEFILE_LIST)))
PKG   := $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
UVER  := $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
DTYPE := +dfsg
VER   ?= $(subst $(DTYPE),,$(UVER))

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
ifeq ($(DEB_HOST_ARCH_CPU),i386)
	MARCH_FLAG :="i686"
else
	MARCH_FLAG :=""
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBINDIR=games \
		-DDATADIR=share/games/spring \
		-DLIBDIR=lib/spring \
		-DAI_LIBS_DIR=lib/spring \
		-DAI_DATA_DIR=share/games/spring \
		-DAI_FIND_QUIETLY=FALSE \
		-DJAVA_FIND_REQUIRED=TRUE \
		-DCMAKE_BUILD_TYPE=RELWITHDEBINFO \
		-DMARCH_FLAG=$(MARCH_FLAG)

override_dh_auto_build:
	dh_auto_build
	cd $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/test && make tests

override_dh_strip:
	dh_strip --dbg-package=spring-dbg

override_dh_installchangelogs:
	dh_installchangelogs doc/changelog.txt

override_dh_auto_install:
	dh_auto_install
	# Remove empty directories
	find $(CURDIR) -type d -empty -delete

.PHONY: get-orig-source
## http://wiki.debian.org/onlyjob/get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
	&& tar -xf $(PKG)_$(VER).orig.tar.* --directory $(PKG)-$(VER) --strip-components 1 \
	|| $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) \
	&& $(RM) -r -v \
		cont/fonts/FreeSansBold.otf \
		cont/fonts/COPYING \
		installer/nsis_plugins/*.dll \
		include/AL \
		include/SDL2 \
		include/GL \
		rts/spring.exe.manifest \
		tools/pr-downloader \
		AI/Wrappers/JavaOO/jlib/*.jar
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	&& $(RM) -r "$(PKG)-$(VER)"
